#ifndef Lib_Arguments_h
#define Lib_Arguments_h

#include <vector>
#include <string>

namespace Lib {

class Arguments {
public:
  typedef std::pair<std::string,std::string> Argument;
public:
  Arguments();
  Arguments(int,char**);
  Arguments(const std::vector<std::string>&);
  Arguments(const std::string&);
  Arguments(const std::vector<Argument>&);
  Arguments(const Arguments&);
  virtual ~Arguments();
  std::string tostring(const std::string& = " ") const;
  std::vector<std::string> tovector() const;
  bool isAnArgument(const std::string&) const;
  unsigned int number() const;
  bool find(const std::string&,std::string&) const;
  bool find(const std::string&,bool&) const;
  bool find(const std::string&,unsigned int&) const;
  bool find(const std::string&,int&) const;
  bool find(const std::string&,double&) const;
  bool match(const std::string&,std::string&,std::string&) const;
  bool add(const std::string&,const std::string&);
  int remove(const std::string&);
  bool first(std::string&,std::string&) const;
  bool last(std::string&,std::string&) const;
  bool file(std::string&) const;
  bool knownOptions(const std::vector<std::string>&) const;
  void argcv(int&,char**&) const;
  const std::vector<Argument>& args() const;
  void add(const std::vector<std::string>&);
private:
  std::vector<Argument> fArgs;
};

}

#endif



