#ifndef Lib_Out_h
#define Lib_Out_h

namespace Slash {namespace Core {class IWriter;}}

#include <string>

#include <Lib/typedefs.h>

namespace Lib {

class sout;

class Out {
public:
  typedef Out& (*OutFunc)(Out&); //For Lib::endl;
public:
  Out(Slash::Core::IWriter&);
  virtual ~Out();
private:
  Out(const Out&);
  Out& operator =(const Out&);
public:
  Out& operator<<(const char*);
  Out& operator<<(const std::string&);
  Out& operator<<(bool);
  Out& operator<<(int);
  Out& operator<<(double);
  Out& operator<<(float);
  Out& operator<<(unsigned int);
  Out& operator<<(Lib::int64);
  Out& operator<<(Lib::uint64);
  Out& operator<<(const void*);
  Out& operator<<(OutFunc);
  Out& operator<<(const sout&);
  Out& operator<<(char);
private:
  Slash::Core::IWriter& fWriter;
};

Out& dot_endl(Out&);
Out& endl(Out&);
Out& tab(Out&);

}

#endif
