// this :
#include <Lib/Out.h>

#include <Slash/Core/IWriter.h>
#include <Lib/sout.h>

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::dot_endl(
 Out& aOut
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return aOut << ".\n";
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::endl(
 Out& aOut
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return aOut << "\n";
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::tab(
 Out& aOut
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return aOut << "\t";
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
Lib::Out::Out(
 Slash::Core::IWriter& aWriter
)
:fWriter(aWriter)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out::~Out(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out::Out(
 const Out& aOut
)
:fWriter(aOut.fWriter)
//////////////////////////////////////////////////////////////////////////////
// private.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator =(
 const Lib::Out&
)
//////////////////////////////////////////////////////////////////////////////
// private.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator<<(
 const char* aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fWriter.write(std::string(aValue));
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator<<(
 const std::string& aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fWriter.write(aValue);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator<<(
 OutFunc aFunc
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return aFunc(*this);
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator<<(
 bool aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aValue) 
    fWriter.write("true");
  else 
    fWriter.write("false");
  return *this;
}
#include <stdio.h>
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator<<(
 int aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,"%d",aValue);
  fWriter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator<<(
 float aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,"%f",aValue);
  fWriter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator<<(
 double aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,"%g",aValue);
  fWriter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator<<(
 unsigned int aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,"%d",aValue);
  fWriter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator<<(
 Lib::int64 aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,LIB_INT64_FORMAT,aValue);
  fWriter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator<<(
 Lib::uint64 aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,LIB_UINT64_FORMAT,aValue);
  fWriter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator<<(
 const void* aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,"%lx",(unsigned long)aValue);
  fWriter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator<<(
 char aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  if(  
     ( (aValue>='0')&&(aValue<='9') ) ||
     ( (aValue>='a')&&(aValue<='z') ) ||
     ( (aValue>='A')&&(aValue<='Z') ) 
     ) {
    ::sprintf(s,"%c",aValue);
  } else {
    ::sprintf(s,"%d",aValue);
  }
  fWriter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Lib::Out& Lib::Out::operator<<(
 const Lib::sout& aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fWriter.write("\"");
  fWriter.write(aValue);
  fWriter.write("\"");
  return *this;
}
