@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package osc_obuild with version v16r5.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\project\version\obuild
REM #   DOS> DOS\build_release
REM # or :
REM #   DOS> call DOS\build_release.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_osc_obuild_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_osc_obuild_path=%obuild_osc_obuild_path:~0,-12%

SET obuild_verbose=no
SET obuild_set_x=no
SET obuild_erase_dir_bin=no

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   DOS\run [Options]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -x : execute with ECHO ON"
  ECHO   -e : erase binary directory.
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

IF NOT "%1%" == "-e" GOTO end_if_e
  SET obuild_erase_dir_bin=yes
  SHIFT
  GOTO next_arg
:end_if_e

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF "%obuild_erase_dir_bin%" == "yes" (
  IF EXIST "%obuild_osc_obuild_path%\%obuild_dir_bin%" RMDIR /S /Q "%obuild_osc_obuild_path%\%obuild_dir_bin%"
  GOTO obuild_return
)

IF NOT EXIST "%obuild_osc_obuild_path%\%obuild_dir_bin%" MKDIR "%obuild_osc_obuild_path%\%obuild_dir_bin%"

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_0=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF EXIST osc_obuild RMDIR /S /Q osc_obuild
IF NOT EXIST osc_obuild MKDIR osc_obuild
cd osc_obuild
IF NOT EXIST v16r5 MKDIR v16r5
cd v16r5
IF NOT EXIST lib MKDIR lib
IF NOT EXIST bin MKDIR bin
IF NOT EXIST Resources MKDIR Resources
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_dir_project=%%d

IF EXIST "%obuild_dir_project%\Versions" DEL "%obuild_dir_project%\Versions"
ECHO package foreign v1r4p0   >> "%obuild_dir_project%\Versions"


IF NOT EXIST "%obuild_osc_obuild_path%\%obuild_dir_bin%" MKDIR "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_osc_obuild_path%\%obuild_dir_bin%\obuild_find.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_osc_obuild_path%\%obuild_dir_bin%\obuild_find.exe" "%obuild_osc_obuild_path%\obuild\cpp\obuild_find.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_find.obj DEL obuild_find.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  foreign v1r4p0`) DO SET obuild_foreign_path=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT DEFINED obuild_foreign_path  ECHO Can't find foreign package.  && GOTO obuild_return

IF NOT EXIST "%obuild_foreign_path%\..\v1r4p0"  ECHO WARNING : Directory %obuild_foreign_path%\..\v1r4p0 not found.  && GOTO end_if_release_1
IF NOT EXIST "%obuild_dir_project%\Resources\foreign\.\v1r4p0" MKDIR "%obuild_dir_project%\Resources\foreign\.\v1r4p0"
XCOPY /E /Q "%obuild_foreign_path%\..\v1r4p0" "%obuild_dir_project%\Resources\foreign\.\v1r4p0" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_1



FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  obuild v1r4p0`) DO SET obuild_obuild_path=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT DEFINED obuild_obuild_path  ECHO Can't find obuild package.  && GOTO obuild_return

IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_obuild_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_2
IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%\owrap.exe" GOTO end_if_copy_3
  COPY "%obuild_obuild_path%\%obuild_dir_bin%\owrap.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_3
:end_if_release_2
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  obuild v1r4p0`) DO SET obuild_obuild_path=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT DEFINED obuild_obuild_path  ECHO Can't find obuild package.  && GOTO obuild_return

IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_obuild_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_4
IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%\obuild.exe" GOTO end_if_copy_5
  COPY "%obuild_obuild_path%\%obuild_dir_bin%\obuild.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_5
:end_if_release_4

IF NOT EXIST "%obuild_osc_obuild_path%\release\License"  ECHO WARNING : File %obuild_osc_obuild_path%\release\License not found.  && GOTO end_if_release_7
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_obuild_path%\release\License" "%obuild_dir_project%\." 1> copy_exe_error
@IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_release_7
IF NOT EXIST "%obuild_osc_obuild_path%\%obuild_dir_bin%" MKDIR "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_osc_obuild_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_osc_obuild_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_osc_obuild_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_8
IF NOT EXIST "%obuild_osc_obuild_path%\release\Windows_NT\setup.bat"  ECHO WARNING : File %obuild_osc_obuild_path%\release\Windows_NT\setup.bat not found.  && GOTO end_if_release_9
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_obuild_path%\release\Windows_NT\setup.bat" "%obuild_dir_project%\." 1> copy_exe_error
@IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_release_9
:end_if_platform_8
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe`) DO SET obuild_platform_signature=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF EXIST "%obuild_dir_project%\lib" RMDIR /S /Q "%obuild_dir_project%\lib"
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF EXIST osc_obuild-v16r5-%obuild_platform_signature%.zip DEL osc_obuild-v16r5-%obuild_platform_signature%.zip
zip -q -r osc_obuild-v16r5-%obuild_platform_signature%.zip osc_obuild
cd "%obuild_osc_obuild_path%\obuild"
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF EXIST obuild_platform.exe DEL obuild_platform.exe
cd "%obuild_pwd_osc_obuild_0%"
SET obuild_pwd_osc_obuild_0=
:obuild_return
ENDLOCAL
@ECHO ON
